
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <math.h>
#include <assert.h>

#define ceild(n,d)  ceil(((double)(n))/((double)(d)))
#define floord(n,d) floor(((double)(n))/((double)(d)))
#define max(x,y)    ((x) > (y)? (x) : (y))
#define min(x,y)    ((x) < (y)? (x) : (y))

double A[N][N+13];

void init_arrays()
{
  int i, j;
  for (i=0; i<N; i++) 
    for (j=0; j<N; j++) 
      A[i][j] = i*i+j*j;
}

double rtclock()
{
  struct timezone tzp;
  struct timeval tp;
  int stat;
  gettimeofday (&tp, &tzp);
  return (tp.tv_sec + tp.tv_usec*1.0e-6);
}

int main()
{
  init_arrays();

  double annot_t_start=0, annot_t_end=0, annot_t_total=0;
  int annot_i;

  for (annot_i=0; annot_i<REPS; annot_i++)
  {
    annot_t_start = rtclock();
    

/**-- (Generated by ancc)
Input problem sizes:
  N = 1024 
  T = 1024 
Best performance parameters:
  IVEC = True 
  PAR = True 
  SCREP = True 
  T1_1 = 32 
  T1_2 = 32 
  T1_3 = 64 
  T2_1 = 1 
  T2_2 = 1 
  T2_3 = 8 
  U1 = 1 
  U2 = 8 
  U3 = 1 
--**/

  

register int i,j,k,t; 
register int c1t, c2t, c3t, c4t, c5t, c6t, c7t, c8t, c9t, c10t, c11t, c12t; 
register int newlb_c1, newlb_c2, newlb_c3, newlb_c4, newlb_c5, newlb_c6, 
  newlb_c7, newlb_c8, newlb_c9, newlb_c10, newlb_c11, newlb_c12; 
register int newub_c1, newub_c2, newub_c3, newub_c4, newub_c5, newub_c6, 
  newub_c7, newub_c8, newub_c9, newub_c10, newub_c11, newub_c12; 


	
	int c1, c2, c3, c4, c5, c6, c7, c8, c9;

	register int lb, ub, lb1, ub1, lb2, ub2;
/* Generated from PLuTo-produced CLooG file by CLooG v0.14.1 64 bits in 0.18s. */
for (c1=-1;c1<=floord(2*T+N-4,32);c1++) {
	lb1=max(max(0,ceild(32*c1-T+1,32)),ceild(16*c1-15,32));
	ub1=min(min(floord(32*c1+31,32),floord(32*c1+N+29,64)),floord(T+N-3,32));
#pragma omp parallel for shared(c1,lb1,ub1) private(c2,c3,c4,c5,c6,c7,c8,c9)
	for (c2=lb1; c2<=ub1; c2++) {
/*@ begin Loop(
transform Composite(
  regtile = (['c3', 'c6', 'c7'],[1, 8, 1]),
  scalarreplace = (True, 'double'),
  vector = (True, ['ivdep','vector always']))

    for (c3=max(max(max(max(ceild(64*c2-N-508,512),ceild(16*c1-255,256)),ceild(16*c2-255,256)),0),ceild(64*c1-64*c2-509,512));c3<=min(min(min(min(floord(T+N-3,256),floord(32*c2+T+N+28,512)),floord(32*c1+N+60,512)),floord(32*c1-32*c2+N+29,256)),floord(64*c2+N+59,512));c3++) {
      for (c6=max(max(max(max(max(ceild(16*c1-31,32),0),ceild(16*c2-31,32)),8*c3),ceild(64*c2-N-60,64)),ceild(64*c1-64*c2-61,64));c6<=min(min(min(min(min(8*c3+7,floord(32*c1-32*c2+N+29,32)),floord(32*c2+T+N+28,64)),floord(64*c2+N+59,64)),floord(32*c1+N+60,64)),floord(T+N-3,32));c6++) {
        for (c7=max(max(max(max(32*c6-N+2,-32*c2+64*c6-N-29),32*c2-N+2),0),32*c1-32*c2);c7<=min(min(min(min(32*c1-32*c2+31,T-1),-32*c2+64*c6+62),32*c2+30),floord(64*c6+61,2));c7++) {
          for (c8=max(max(64*c6-c7-N+2,c7+1),32*c2);c8<=min(min(32*c2+31,c7+N-2),64*c6-c7+62);c8++) {
            for (c9=max(64*c6,c7+c8+1);c9<=min(c7+c8+N-2,64*c6+63);c9++) {
              A[-c7+c8][-c7-c8+c9]=(A[1+-c7+c8][1+-c7-c8+c9]+A[1+-c7+c8][-c7-c8+c9]+A[1+-c7+c8][-c7-c8+c9-1]+A[-c7+c8][1+-c7-c8+c9]+A[-c7+c8][-c7-c8+c9]+A[-c7+c8][-c7-c8+c9-1]+A[-c7+c8-1][1+-c7-c8+c9]+A[-c7+c8-1][-c7-c8+c9]+A[-c7+c8-1][-c7-c8+c9-1])/9 ;
            }
          }
        }
      }
    }

) @*/{
  for (c3=max(max(max(max(ceild(64*c2-N-508,512),ceild(16*c1-255,256)),ceild(16*c2-255,256)),0),ceild(64*c1-64*c2-509,512)); c3<=min(min(min(min(floord(T+N-3,256),floord(32*c2+T+N+28,512)),floord(32*c1+N+60,512)),floord(32*c1-32*c2+N+29,256)),floord(64*c2+N+59,512)); c3++ ) {
    for (c6t=max(max(max(max(max(ceild(16*c1-31,32),0),ceild(16*c2-31,32)),8*c3),ceild(64*c2-N-60,64)),ceild(64*c1-64*c2-61,64)); c6t<=min(min(min(min(min(8*c3+7,floord(32*c1+N-32*c2+29,32)),floord(32*c2+T+N+28,64)),floord(64*c2+N+59,64)),floord(32*c1+N+60,64)),floord(T+N-3,32))-7; c6t=c6t+8) {
      for (c6=c6t; c6<=c6t+7; c6=c6+1) {
        for (c7=max(max(max(max(32*c6-N+2,-32*c2+64*c6-N-29),32*c2-N+2),0),32*c1-32*c2); c7<=min(min(min(min(32*c1-32*c2+31,T-1),-32*c2+64*c6+62),32*c2+30),floord(64*c6+61,2)); c7++ ) {
          for (c8=max(max(64*c6-c7-N+2,c7+1),32*c2); c8<=min(min(32*c2+31,c7+N-2),64*c6-c7+62); c8++ ) {
            register int cbv_1, cbv_2;
            cbv_1=max(64*c6,c7+c8+1);
            cbv_2=min(c7+c8+N-2,64*c6+63);
#pragma ivdep
#pragma vector always
            for (c9=cbv_1; c9<=cbv_2; c9++ ) {
              double scv_1;
              scv_1=A[-c7+c8][-c7-c8+c9];
              scv_1=(A[1+-c7+c8][1+-c7-c8+c9]+A[1+-c7+c8][-c7-c8+c9]+A[1+-c7+c8][-c7-c8+c9-1]+A[-c7+c8][1+-c7-c8+c9]+scv_1+A[-c7+c8][-c7-c8+c9-1]+A[-c7+c8-1][1+-c7-c8+c9]+A[-c7+c8-1][-c7-c8+c9]+A[-c7+c8-1][-c7-c8+c9-1])/9;
              A[-c7+c8][-c7-c8+c9]=scv_1;
            }
          }
        }
      }
    }
    for (c6=c6t; c6<=min(min(min(min(min(8*c3+7,floord(32*c1-32*c2+N+29,32)),floord(32*c2+T+N+28,64)),floord(64*c2+N+59,64)),floord(32*c1+N+60,64)),floord(T+N-3,32)); c6=c6+1) {
      for (c7=max(max(max(max(32*c6-N+2,-32*c2+64*c6-N-29),32*c2-N+2),0),32*c1-32*c2); c7<=min(min(min(min(32*c1-32*c2+31,T-1),-32*c2+64*c6+62),32*c2+30),floord(64*c6+61,2)); c7++ ) {
        for (c8=max(max(64*c6-c7-N+2,c7+1),32*c2); c8<=min(min(32*c2+31,c7+N-2),64*c6-c7+62); c8++ ) {
          register int cbv_3, cbv_4;
          cbv_3=max(64*c6,c7+c8+1);
          cbv_4=min(c7+c8+N-2,64*c6+63);
#pragma ivdep
#pragma vector always
          for (c9=cbv_3; c9<=cbv_4; c9++ ) {
            double scv_2;
            scv_2=A[-c7+c8][-c7-c8+c9];
            scv_2=(A[1+-c7+c8][1+-c7-c8+c9]+A[1+-c7+c8][-c7-c8+c9]+A[1+-c7+c8][-c7-c8+c9-1]+A[-c7+c8][1+-c7-c8+c9]+scv_2+A[-c7+c8][-c7-c8+c9-1]+A[-c7+c8-1][1+-c7-c8+c9]+A[-c7+c8-1][-c7-c8+c9]+A[-c7+c8-1][-c7-c8+c9-1])/9;
            A[-c7+c8][-c7-c8+c9]=scv_2;
          }
        }
      }
    }
  }
}

  }
 }

 annot_t_end = rtclock();
 annot_t_total += annot_t_end - annot_t_start;
  }
  
  annot_t_total = annot_t_total / REPS;
  printf("%f\n", annot_t_total);
  
  return ((int) A[0][0]); 
  
}
                                  
